'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.forward = undefined;

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

require('colors');

var _player = require('./player');

var _netease = require('../../utils/netease');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var forward = exports.forward = function () {
  var _ref = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee(ctx, next) {
    var req, url, body, json;
    return _regenerator2.default.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            req = ctx.request;

            if (Object.prototype.hasOwnProperty.call(req, 'body')) {
              _context.next = 3;
              break;
            }

            return _context.abrupt('return', next());

          case 3:
            url = void 0;
            _context.prev = 4;
            body = _netease.Netease.decryptLinuxForwardApi(req.body.eparams);
            json = JSON.parse(body);

            url = json.url;
            _context.next = 14;
            break;

          case 10:
            _context.prev = 10;
            _context.t0 = _context['catch'](4);

            console.log('Parse body failed.');
            throw new Error(_context.t0);

          case 14:
            console.log('API:'.green, url);

            if (!(url !== 'http://music.163.com/api/song/enhance/player/url')) {
              _context.next = 17;
              break;
            }

            return _context.abrupt('return', next());

          case 17:
            return _context.abrupt('return', (0, _player.player)(ctx, next));

          case 18:
          case 'end':
            return _context.stop();
        }
      }
    }, _callee, undefined, [[4, 10]]);
  }));

  return function forward(_x, _x2) {
    return _ref.apply(this, arguments);
  };
}();

exports.default = forward;