'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.get = undefined;

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _models = require('../../models');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var get = exports.get = function () {
  var _ref = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee(ctx) {
    var songId, pair;
    return _regenerator2.default.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            songId = ctx.params.songId;

            if (/^\d+$/.test(songId)) {
              _context.next = 5;
              break;
            }

            ctx.body = {
              error: -1
            };
            _context.next = 9;
            break;

          case 5:
            _context.next = 7;
            return _models.Pair.findOne({
              include: [{
                as: 'song',
                model: _models.Song
              }],
              order: [['updatedAt', 'DESC']]
            });

          case 7:
            pair = _context.sent;

            if (pair) {
              ctx.body = {
                error: 0,
                result: pair
              };
            } else {
              ctx.body = {
                error: -2
              };
            }

          case 9:
          case 'end':
            return _context.stop();
        }
      }
    }, _callee, undefined);
  }));

  return function get(_x) {
    return _ref.apply(this, arguments);
  };
}();

exports.default = get;