'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.proxy = undefined;

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _stringify = require('babel-runtime/core-js/json/stringify');

var _stringify2 = _interopRequireDefault(_stringify);

var _typeof2 = require('babel-runtime/helpers/typeof');

var _typeof3 = _interopRequireDefault(_typeof2);

var _assign = require('babel-runtime/core-js/object/assign');

var _assign2 = _interopRequireDefault(_assign);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _zlib = require('zlib');

var _zlib2 = _interopRequireDefault(_zlib);

var _config = require('../../config');

var _config2 = _interopRequireDefault(_config);

var _utils = require('../../utils');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var proxy = exports.proxy = function () {
  var _ref = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee(ctx, next) {
    var req, ip, url, newHeader, options, result, headers, body, stream;
    return _regenerator2.default.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            req = ctx.request;

            if (!(req.url.indexOf('/api/plugin') !== -1)) {
              _context.next = 7;
              break;
            }

            ctx.body = req.rawBody;
            _context.next = 5;
            return next();

          case 5:
            _context.next = 32;
            break;

          case 7:
            if (!(req.method === 'POST')) {
              _context.next = 32;
              break;
            }

            ip = _config2.default.forceIp ? _config2.default.forceIp : '223.252.199.7';
            url = 'http://' + ip + req.url;
            newHeader = (0, _assign2.default)({}, req.headers, {
              host: 'music.163.com',
              'x-real-ip': '202.114.79.' + (Math.floor(Math.random() * 255) + 1)
            });
            options = {
              url: url,
              headers: newHeader,
              method: 'post',
              encoding: null,
              gzip: true
            };

            if (req.rawBody) {
              options.body = req.rawBody;
            }
            result = void 0;
            _context.prev = 14;
            _context.next = 17;
            return (0, _utils.sendRequest)(options);

          case 17:
            result = _context.sent;
            _context.next = 24;
            break;

          case 20:
            _context.prev = 20;
            _context.t0 = _context['catch'](14);

            console.log('Cannot get orignal response.'.red);
            throw new Error(_context.t0);

          case 24:
            headers = result.headers;
            body = result.body;

            ctx.body = body.toString();
            // console.log(ctx.body);
            _context.next = 29;
            return next();

          case 29:

            if ((0, _typeof3.default)(ctx.body) === 'object') {
              ctx.body = (0, _stringify2.default)(ctx.body);
            }
            if (typeof ctx.body === 'string') {
              ctx.compress = true;
              stream = _zlib2.default.createGzip();

              stream.end(ctx.body);
              ctx.body = stream;
              headers['content-encoding'] = 'gzip';
            } else {
              delete headers['content-encoding'];
            }
            // console.log(headers);
            ctx.set(headers);
            // console.log(ctx.body);

          case 32:
          case 'end':
            return _context.stop();
        }
      }
    }, _callee, this, [[14, 20]]);
  }));

  return function proxy(_x, _x2) {
    return _ref.apply(this, arguments);
  };
}();

exports.default = proxy;