'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

exports.default = function (sequelize, DataTypes) {
  var Recent = sequelize.define('Recent', {
    songId: {
      type: DataTypes.INTEGER,
      primaryKey: true
    }
  });

  Recent.associate = function (Song) {
    Recent.hasOne(Song, {
      foreignKey: 'songId',
      as: 'song'
    });
  };

  return Recent;
};