'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.download = undefined;

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _stringify = require('babel-runtime/core-js/json/stringify');

var _stringify2 = _interopRequireDefault(_stringify);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

require('colors');

var _utils = require('../../utils');

var _dead = require('./dead');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var utils = new _utils.Utils();

var download = exports.download = function () {
  var _ref = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee(ctx, next) {
    var data, songId, pair, songInfo, urlInfo;
    return _regenerator2.default.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            data = ctx.body;

            if (!(_utils.Netease.getDownloadReturnCode(data) === 200)) {
              _context.next = 3;
              break;
            }

            return _context.abrupt('return', console.log('The song URL is '.green + data.data.url));

          case 3:
            songId = _utils.Netease.getDownloadSongId(data);
            pair = void 0;
            _context.prev = 5;
            _context.next = 8;
            return (0, _dead.checkPairMusic)(songId);

          case 8:
            pair = _context.sent;
            _context.next = 15;
            break;

          case 11:
            _context.prev = 11;
            _context.t0 = _context['catch'](5);

            console.log(_context.t0);
            throw new Error(_context.t0);

          case 15:
            if (!pair) {
              _context.next = 28;
              break;
            }

            _context.prev = 16;
            _context.next = 19;
            return _utils.Netease.modifyPlayerApiCustom(pair, data.data);

          case 19:
            data.data = _context.sent;
            _context.next = 26;
            break;

          case 22:
            _context.prev = 22;
            _context.t1 = _context['catch'](16);

            console.log('No resource.'.red);
            throw new Error(_context.t1);

          case 26:
            _context.next = 65;
            break;

          case 28:
            songInfo = void 0;
            _context.prev = 29;
            _context.next = 32;
            return _utils.Utils.getSongInfo(songId);

          case 32:
            songInfo = _context.sent;
            _context.next = 39;
            break;

          case 35:
            _context.prev = 35;
            _context.t2 = _context['catch'](29);

            console.log(_context.t2);
            throw new Error(_context.t2);

          case 39:
            urlInfo = void 0;
            _context.prev = 40;
            _context.next = 43;
            return utils.getUrlInfo(songInfo);

          case 43:
            urlInfo = _context.sent;
            _context.next = 50;
            break;

          case 46:
            _context.prev = 46;
            _context.t3 = _context['catch'](40);

            console.log(_context.t3);
            throw new Error(_context.t3);

          case 50:
            if (!urlInfo) {
              _context.next = 63;
              break;
            }

            _context.prev = 51;
            _context.next = 54;
            return _utils.Netease.modifyDownloadApiCustom(urlInfo, data.data);

          case 54:
            data.data = _context.sent;
            _context.next = 61;
            break;

          case 57:
            _context.prev = 57;
            _context.t4 = _context['catch'](51);

            console.log('No resource.'.red);
            throw new Error(_context.t4);

          case 61:
            _context.next = 65;
            break;

          case 63:
            console.log('No resource.'.red);
            (0, _dead.handleDeadMusic)(songId, songInfo);

          case 65:

            ctx.body = (0, _stringify2.default)(data);
            return _context.abrupt('return', next());

          case 67:
          case 'end':
            return _context.stop();
        }
      }
    }, _callee, undefined, [[5, 11], [16, 22], [29, 35], [40, 46], [51, 57]]);
  }));

  return function download(_x, _x2) {
    return _ref.apply(this, arguments);
  };
}();

exports.default = download;