'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.save = undefined;

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _models = require('../../models');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var save = exports.save = function () {
  var _ref = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee(ctx) {
    var req, result, _req$body, songId, plugin, hash, name, artist, album, albumPic;

    return _regenerator2.default.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            req = ctx.request;
            result = {};
            _req$body = req.body, songId = _req$body.songId, plugin = _req$body.plugin, hash = _req$body.hash, name = _req$body.name, artist = _req$body.artist, album = _req$body.album, albumPic = _req$body.albumPic;

            if (!/^QQ Music|Kugou$/.test(plugin)) {
              result.error = -1;
              ctx.body = result;
            } else if (!/^\d+$/.test(songId)) {
              result.error = -1;
              ctx.body = result;
            } else if (!/^[0-9,a-z,A-Z]+$/.test(songId)) {
              result.error = -1;
              ctx.body = result;
            } else {
              _models.Pair.upsert({
                songId: songId, plugin: plugin, hash: hash, name: name, artist: artist, album: album, albumPic: albumPic
              }).then().catch(function (err) {
                return console.log(err);
              });
              _models.Recent.destroy({
                where: { songId: songId }
              }).then().catch(function (err) {
                return console.log(err);
              });
              result.error = 0;
              ctx.body = result;
            }

          case 4:
          case 'end':
            return _context.stop();
        }
      }
    }, _callee, undefined);
  }));

  return function save(_x) {
    return _ref.apply(this, arguments);
  };
}();

exports.default = save;