'use strict';

var _stringify = require('babel-runtime/core-js/json/stringify');

var _stringify2 = _interopRequireDefault(_stringify);

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _getIterator2 = require('babel-runtime/core-js/get-iterator');

var _getIterator3 = _interopRequireDefault(_getIterator2);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

require('colors');

var _common = require('../common');

var common = _interopRequireWildcard(_common);

var _config = require('../../config');

var _config2 = _interopRequireDefault(_config);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var QQ = function () {
  function QQ() {
    (0, _classCallCheck3.default)(this, QQ);

    this.name = 'QQ Music';
    this.order = 1;
    this.baseUrl = 'isure.stream.qqmusic.qq.com';
    if (_config2.default.proxy && _config2.default.proxy.length > 0) {
      this.baseSearchApi = 'http://' + _config2.default.proxy + '/c.y.qq.com';
      this.baseVKeyApi = 'http://' + _config2.default.proxy + '/u.y.qq.com';
    } else {
      this.baseSearchApi = 'https://c.y.qq.com';
      this.baseVKeyApi = 'https://u.y.qq.com';
    }
    console.log(this.baseVKeyApi);
  }

  (0, _createClass3.default)(QQ, [{
    key: 'search',
    value: function () {
      var _ref = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee(keyword) {
        var options, data, _result, result, _iteratorNormalCompletion, _didIteratorError, _iteratorError, _iterator, _step, e, list, prefix, bitrate, filesize, type, fromtag;

        return _regenerator2.default.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                options = {
                  url: this.baseSearchApi + '/soso/fcgi-bin/client_search_cp?ct=24&qqmusic_ver=1298&new_json=1&remoteplace=txt.yqq.song&t=0&aggr=1&cr=1&catZhida=1&lossless=1&flag_qc=0&p=1&n=1&w=' + encodeURIComponent(keyword) + '&g_tk=5381&loginUin=0&hostUin=0&format=json&inCharset=utf8&outCharset=utf-8&notice=0&platform=yqq&needNewCode=0'
                };
                data = void 0;
                _context.prev = 2;
                _context.next = 5;
                return common.sendRequest(options);

              case 5:
                _result = _context.sent;

                data = JSON.parse(_result.body);
                _context.next = 12;
                break;

              case 9:
                _context.prev = 9;
                _context.t0 = _context['catch'](2);
                throw new Error(_context.t0);

              case 12:
                result = [];

                if (!(data.code === 0 && data.data.song.list.length > 0)) {
                  _context.next = 33;
                  break;
                }

                _iteratorNormalCompletion = true;
                _didIteratorError = false;
                _iteratorError = undefined;
                _context.prev = 17;

                for (_iterator = (0, _getIterator3.default)(data.data.song.list); !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
                  e = _step.value;
                  list = e.file;
                  prefix = void 0;
                  bitrate = void 0;
                  filesize = void 0;
                  type = void 0;
                  fromtag = void 0;

                  if (list.size_128 && list.size_128 > 0) {
                    prefix = 'M500';
                    type = 'mp3';
                    bitrate = 128000;
                    filesize = list.size_128;
                    fromtag = 30;
                  }
                  if (list.size_320 && list.size_320 > 0) {
                    prefix = 'M800';
                    type = 'mp3';
                    bitrate = 320000;
                    filesize = list.size_320;
                    fromtag = 30;
                  }
                  if (list.size_flac && list.size_flac > 0) {
                    prefix = 'F000';
                    type = 'flac';
                    bitrate = 999000;
                    filesize = list.size_flac;
                    fromtag = 53;
                  }
                  result.push({
                    name: e.name || 'V.A.',
                    artist: e.singer.name || 'V.A.',
                    filesize: filesize,
                    hash: '',
                    songmid: e.mid,
                    mid: list.media_mid,
                    bitrate: String(bitrate),
                    prefix: prefix,
                    type: type,
                    fromtag: fromtag
                  });
                }
                _context.next = 25;
                break;

              case 21:
                _context.prev = 21;
                _context.t1 = _context['catch'](17);
                _didIteratorError = true;
                _iteratorError = _context.t1;

              case 25:
                _context.prev = 25;
                _context.prev = 26;

                if (!_iteratorNormalCompletion && _iterator.return) {
                  _iterator.return();
                }

              case 28:
                _context.prev = 28;

                if (!_didIteratorError) {
                  _context.next = 31;
                  break;
                }

                throw _iteratorError;

              case 31:
                return _context.finish(28);

              case 32:
                return _context.finish(25);

              case 33:
                return _context.abrupt('return', result);

              case 34:
              case 'end':
                return _context.stop();
            }
          }
        }, _callee, this, [[2, 9], [17, 21, 25, 33], [26,, 28, 32]]);
      }));

      function search(_x) {
        return _ref.apply(this, arguments);
      }

      return search;
    }()
  }, {
    key: 'getUrl',
    value: function () {
      var _ref2 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee2(data) {
        var guid, url, res, vkey;
        return _regenerator2.default.wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                guid = QQ.getGUid();
                url = this.baseVKeyApi + '/cgi-bin/musicu.fcg?loginUin=0&data=' + encodeURIComponent((0, _stringify2.default)({
                  req: {
                    module: 'vkey.GetVkeyServer',
                    method: 'CgiGetVkey',
                    param: {
                      guid: guid,
                      songmid: [data.songmid],
                      songtype: [0],
                      uin: '0',
                      loginflag: 1,
                      platform: '20'
                    }
                  },
                  comm: { uin: 0, format: 'json', ct: 20, cv: 0 }
                }));
                _context2.next = 4;
                return common.sendRequest({ url: url });

              case 4:
                res = _context2.sent;
                vkey = JSON.parse(res.body).req.data.midurlinfo[0].vkey;

                if (vkey) {
                  _context2.next = 8;
                  break;
                }

                return _context2.abrupt('return', null);

              case 8:
                return _context2.abrupt('return', 'http://' + this.baseUrl + '/' + data.prefix + data.mid + '.' + data.type + '?vkey=' + vkey + '&guid=' + guid + '&uin=0&fromtag=' + data.fromtag);

              case 9:
              case 'end':
                return _context2.stop();
            }
          }
        }, _callee2, this);
      }));

      function getUrl(_x2) {
        return _ref2.apply(this, arguments);
      }

      return getUrl;
    }()
  }], [{
    key: 'getGUid',
    value: function getGUid() {
      var currentMs = new Date().getUTCMilliseconds();
      return '' + Math.round(2147483647 * Math.random()) * currentMs % 1e10;
    }
  }]);
  return QQ;
}();

module.exports = QQ;